import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.util.*;


// Dibuja la matriz donde vivirn los autmatas
class Matriz extends Canvas implements Runnable
{
  //Hilo necesario para hacer la animacin.
  Thread objHilo;
  
  //DoubleBuffer
  Image imgPantalla;
  Graphics graPantalla;

  //El arreglo bidimensional donde viven los autmatas
  int iAmbiente[][] = new int[30][30];
  
  //Trabajo con nmeros aleatorios
  Random objAzar = new Random();
  
  //Estas dos variables recorren todo el tablero
  int iPosX, iPosY;
  
  //Limites del automata
  int iLimiteVegetales;
  int iLimitePeces;
  int iLimiteTiburones;
  int iMinimoTablero;
  int iMaximoTablero;
  int iEspaciadoTablero;
  int iCorrimientoTablero;
  int iIdentificaVegetalMin;
  int iIdentificaVegetalMax;
  int iIdentificaPezMin;
  int iIdentificaPezMax;
  int iIdentificaTiburonMin;
  int iIdentificaTiburonMax;
  int iAlimentaVegetal; //cuanto sube de energia al comer vegetal
  int iAlimentaPez; //cuanto sube de energia al comerse al pez
  
  public void vParametros(int iLimiteVegetales, int iLimitePeces, int iLimiteTiburones, int iIdentificaVegetalMin,
  						  int iIdentificaVegetalMax, int iIdentificaPezMin, int iIdentificaPezMax, 
  						  int iIdentificaTiburonMin, int iIdentificaTiburonMax, int iAlimentaVegetal,
  						  int iAlimentaPez)
  {
   	//Limites del automata
  	this.iLimiteVegetales = iLimiteVegetales;
  	this.iLimitePeces = iLimitePeces;
  	this.iLimiteTiburones = iLimiteTiburones;
  	this.iMinimoTablero = 1;
  	this.iMaximoTablero = 29;
  	this.iEspaciadoTablero = 17;
  	this.iCorrimientoTablero = 40;
  	this.iIdentificaVegetalMin = iIdentificaVegetalMin;
  	this.iIdentificaVegetalMax = iIdentificaVegetalMax;
  	this.iIdentificaPezMin = iIdentificaPezMin;
  	this.iIdentificaPezMax = iIdentificaPezMax;
  	this.iIdentificaTiburonMin = iIdentificaTiburonMin;
  	this.iIdentificaTiburonMax = iIdentificaTiburonMax;
  	this.iAlimentaVegetal = iAlimentaVegetal;
  	this.iAlimentaPez = iAlimentaPez; 	
  		
  	//Inicializa las variables de recorrido
  	iPosX=0;
  	iPosY=1;
  	
  	for (int iCont1=0; iCont1<30; iCont1++)
  		for (int iCont2=0; iCont2<30; iCont2++)
  			iAmbiente[iCont1][iCont2]=0;
  	
	//Pongo los vegetales
	int iPostX, iPostY;
	for (int iCont=1; iCont<=this.iLimiteVegetales; iCont++)
	{
		do
		{
			iPostX = (int) (objAzar.nextFloat()*(iMaximoTablero-iMinimoTablero))+iMinimoTablero;
			iPostY = (int) (objAzar.nextFloat()*(iMaximoTablero-iMinimoTablero)+iMinimoTablero);
		} while(iAmbiente[iPostX][iPostY]!=0);
		iAmbiente[iPostX][iPostY]=iIdentificaVegetalMin; //Es una planta
	}
	
	//Pongo los peces
	for (int iCont=1; iCont<=this.iLimitePeces; iCont++)
	{
		do
		{
			iPostX = (int) (objAzar.nextFloat()*(iMaximoTablero-iMinimoTablero))+iMinimoTablero;
			iPostY = (int) (objAzar.nextFloat()*(iMaximoTablero-iMinimoTablero)+iMinimoTablero);
		} while(iAmbiente[iPostX][iPostY]!=0);
		iAmbiente[iPostX][iPostY]=(iIdentificaPezMin+iIdentificaPezMax)/2; //Es un pez
	}
	
	//Pongo los tiburones
	for (int iCont=1; iCont<=this.iLimiteTiburones; iCont++)
	{
		do
		{
			iPostX = (int) (objAzar.nextFloat()*(iMaximoTablero-iMinimoTablero))+iMinimoTablero;
			iPostY = (int) (objAzar.nextFloat()*(iMaximoTablero-iMinimoTablero)+iMinimoTablero);
		} while(iAmbiente[iPostX][iPostY]!=0);
		iAmbiente[iPostX][iPostY]=(iIdentificaTiburonMin+iIdentificaTiburonMax)/2; //Es un tiburon
	}
 		
  }
  
  public void paint(Graphics objGrafico)
  {
	//Uso de Double Buffer
    Dimension dimTamano = size();
    int iTamPantX = dimTamano.width;
    int iTamPantY = dimTamano.height;

    //Doble Buffer
    if ((imgPantalla == null))
    {
    	imgPantalla = createImage(iTamPantX, iTamPantY);
        graPantalla = imgPantalla.getGraphics();
    }
	graPantalla.setColor(Color.black);
  	graPantalla.fillRect(0,0,getWidth(), getHeight());
  	
  	//Fuente del grfico
    Font objFuente = new Font("TimesRoman", Font.PLAIN, 12);
  	graPantalla.setFont(objFuente);
  	
  	//Dibujo la matriz en grafico
    graPantalla.setColor(Color.white);
    int iPantallaX, iPantallaY;
  	for (iPantallaX=0; iPantallaX<=iMaximoTablero; iPantallaX++)
  		for (iPantallaY=0; iPantallaY<=iMaximoTablero; iPantallaY++)
  		{
  			if (iAmbiente[iPantallaX][iPantallaY]>=iIdentificaVegetalMin && iAmbiente[iPantallaX][iPantallaY]<=iIdentificaVegetalMax)
  			{
  				graPantalla.setColor(Color.green);
  				graPantalla.drawString("v", iPantallaX*iEspaciadoTablero+iCorrimientoTablero, iPantallaY*iEspaciadoTablero+iCorrimientoTablero);
  			}
  			else if (iAmbiente[iPantallaX][iPantallaY]>=iIdentificaPezMin && iAmbiente[iPantallaX][iPantallaY]<=iIdentificaPezMax)
  			{
  				graPantalla.setColor(Color.blue);
  				graPantalla.drawString("P", iPantallaX*iEspaciadoTablero+iCorrimientoTablero, iPantallaY*iEspaciadoTablero+iCorrimientoTablero);
  			}
			else if (iAmbiente[iPantallaX][iPantallaY]>=iIdentificaTiburonMin)   				
			{
				graPantalla.setColor(Color.red);
  				graPantalla.drawString("T", iPantallaX*iEspaciadoTablero+iCorrimientoTablero, iPantallaY*iEspaciadoTablero+iCorrimientoTablero);
			}
  			else
  			{
  				graPantalla.setColor(Color.white);
    			graPantalla.fillOval(iPantallaX*iEspaciadoTablero+iCorrimientoTablero, iPantallaY*iEspaciadoTablero+iCorrimientoTablero, 2, 2); 
  			}
  		}
  		
	
	objGrafico.drawImage(imgPantalla,0,0,this);	
  }
  
  public void vVivir()
  {
  	/* Si es planta
  	a. Subo en un punto su poder, si pasa de iIdentificaVegetalMax entonces se multiplica
  	b. Si se multiplica queda su poder en promedio
  	c. Coloca el hijo en una casilla al azar
  	d. Si no puede multiplicarse entonces queda su poder estancado en iIdentificaVegetalMax
  	*/
  	if (iAmbiente[iPosX][iPosY]>=iIdentificaVegetalMin && iAmbiente[iPosX][iPosY]<=iIdentificaVegetalMax)
  	{
  			iAmbiente[iPosX][iPosY]++;
  			if (iAmbiente[iPosX][iPosY]>=iIdentificaVegetalMax)
  			{
  				iAmbiente[iPosX][iPosY]=iIdentificaVegetalMax;
				int iCeldaMultiplica = Math.abs(objAzar.nextInt()%9);
				int iCeldaContiguaX = iRetornaPosX(iCeldaMultiplica);
				int iCeldaContiguaY = iRetornaPosY(iCeldaMultiplica);
  				if (iPosX+iCeldaContiguaX>=1 && iPosX+iCeldaContiguaX<iMaximoTablero &&	iPosY+iCeldaContiguaY>=1 && iPosY+iCeldaContiguaY<iMaximoTablero)
  					if (iAmbiente[iPosX+iCeldaContiguaX][iPosY+iCeldaContiguaY]==0)
  					{
  						iAmbiente[iPosX][iPosY]=(iIdentificaVegetalMin+iIdentificaVegetalMax)/2;
  						iAmbiente[iPosX+iCeldaContiguaX][iPosY+iCeldaContiguaY]=(iIdentificaVegetalMin+iIdentificaVegetalMax)/2;
  					}
  			}
  	}		
  	
    /* Si es pez
  	a. Disminuye en un punto su poder
  	b. Chequea si alrededor hay plantas
  	c. Si hay planta se traslada all y sube su poder
  	d. Si su poder pasa de iIdentificaPezMax entonces se multiplica quedando dos peces de iIdentificaPezMin en poder cada uno
  	e. Si no hay planta alrededor entonces se mueve a una casilla al azar.
  	f. Si su poder se pasa de iIdentificaPezMax y no se puede multiplicar se queda en iIdentificaPezMax-1
  	*/
  	if (iAmbiente[iPosX][iPosY]>=iIdentificaPezMin && iAmbiente[iPosX][iPosY]<=iIdentificaPezMax)
  	{
  			//Chequea alrededor si hay planta
			if (iAmbiente[iPosX-1][iPosY-1]>=iIdentificaVegetalMin && iAmbiente[iPosX-1][iPosY-1]<=iIdentificaVegetalMax)
  				vAlimentaPez(iPosX-1, iPosY-1);
  			else if (iAmbiente[iPosX][iPosY-1]>=iIdentificaVegetalMin && iAmbiente[iPosX][iPosY-1]<=iIdentificaVegetalMax)
  				vAlimentaPez(iPosX, iPosY-1);
  			else if (iAmbiente[iPosX+1][iPosY-1]>=iIdentificaVegetalMin && iAmbiente[iPosX+1][iPosY-1]<=iIdentificaVegetalMax)
  				vAlimentaPez(iPosX+1, iPosY-1);
  			else if (iAmbiente[iPosX-1][iPosY]>=iIdentificaVegetalMin && iAmbiente[iPosX-1][iPosY]<=iIdentificaVegetalMax)
  				vAlimentaPez(iPosX-1, iPosY);
  			else if (iAmbiente[iPosX+1][iPosY]>=iIdentificaVegetalMin && iAmbiente[iPosX+1][iPosY]<=iIdentificaVegetalMax)
				vAlimentaPez(iPosX+1, iPosY);
  			else if (iAmbiente[iPosX-1][iPosY+1]>=iIdentificaVegetalMin && iAmbiente[iPosX-1][iPosY+1]<=iIdentificaVegetalMax)
				vAlimentaPez(iPosX-1, iPosY+1);
  			else if (iAmbiente[iPosX][iPosY+1]>=iIdentificaVegetalMin && iAmbiente[iPosX][iPosY+1]<=iIdentificaVegetalMax)
				vAlimentaPez(iPosX, iPosY+1);
  			else if (iAmbiente[iPosX+1][iPosY+1]>=iIdentificaVegetalMin && iAmbiente[iPosX+1][iPosY+1]<=iIdentificaVegetalMax)
				vAlimentaPez(iPosX+1, iPosY+1);
  			else
  			{
  				    iAmbiente[iPosX][iPosY]--;
	  				if (iAmbiente[iPosX][iPosY]<iIdentificaPezMin)
	  				{
	  					iAmbiente[iPosX][iPosY]=0;
	  					//System.out.println("Muere un Pez");
	  				}
					else
					{
			  			//Se mueve a una casilla al azar
	  					int iCeldaContiguaX=1, iCeldaContiguaY=1;
  						do
			 			{
							if (objAzar.nextInt()<0) iCeldaContiguaX = -1; else iCeldaContiguaX = 1;
							if (objAzar.nextInt()<0) iCeldaContiguaY = -1; else iCeldaContiguaY = 1;
	  					}while (iPosX+iCeldaContiguaX<=0 || iPosX+iCeldaContiguaX>=iMaximoTablero || iPosY+iCeldaContiguaY<=0 || iPosY+iCeldaContiguaY>=iMaximoTablero);

						if (iAmbiente[iPosX+iCeldaContiguaX][iPosY+iCeldaContiguaY]==0)
						{
							iAmbiente[iPosX+iCeldaContiguaX][iPosY+iCeldaContiguaY]=iAmbiente[iPosX][iPosY];
							iAmbiente[iPosX][iPosY]=0;
						}
		  			}
			}
 		}
 		
 		/* Si es tiburon 
  		a. Disminuye en un punto su poder
  		b. Chequea si alrededor hay plantas
  		c. Si hay planta se traslada all y sube su poder en 20
  		d. Si su poder pasa de 4000 entonces se multiplica quedando dos peces de 2000 en poder cada uno
  		e. Si no hay planta alrededor entonces se mueve a una casilla al azar.
  		f. Si su poder se pasa de 4000 y no se puede multiplicar se queda en 3999
  		*/
  	  	if (iAmbiente[iPosX][iPosY]>=iIdentificaTiburonMin && iAmbiente[iPosX][iPosY]<=iIdentificaTiburonMax)
  		{
		    //System.out.println(" === Entra === " + iAmbiente[iPosX][iPosY]);
  			//Chequea alrededor si hay pez
			if (iAmbiente[iPosX-1][iPosY-1]>=iIdentificaPezMin && iAmbiente[iPosX-1][iPosY-1]<=iIdentificaPezMax)
  				vAlimentaTiburon(iPosX-1, iPosY-1);
  			else if (iAmbiente[iPosX][iPosY-1]>=iIdentificaPezMin && iAmbiente[iPosX][iPosY-1]<=iIdentificaPezMax)
  				vAlimentaTiburon(iPosX, iPosY-1);
  			else if (iAmbiente[iPosX+1][iPosY-1]>=iIdentificaPezMin && iAmbiente[iPosX+1][iPosY-1]<=iIdentificaPezMax)
  				vAlimentaTiburon(iPosX+1, iPosY-1);
  			else if (iAmbiente[iPosX-1][iPosY]>=iIdentificaPezMin && iAmbiente[iPosX-1][iPosY]<=iIdentificaPezMax)
  				vAlimentaTiburon(iPosX-1, iPosY);
  			else if (iAmbiente[iPosX+1][iPosY]>=iIdentificaPezMin && iAmbiente[iPosX+1][iPosY]<=iIdentificaPezMax)
  				vAlimentaTiburon(iPosX+1, iPosY);
  			else if (iAmbiente[iPosX-1][iPosY+1]>=iIdentificaPezMin && iAmbiente[iPosX-1][iPosY+1]<=iIdentificaPezMax)
  				vAlimentaTiburon(iPosX-1, iPosY+1);
  			else if (iAmbiente[iPosX][iPosY+1]>=iIdentificaPezMin && iAmbiente[iPosX][iPosY+1]<=iIdentificaPezMax)
  				vAlimentaTiburon(iPosX, iPosY+1);
  			else if (iAmbiente[iPosX+1][iPosY+1]>=iIdentificaPezMin && iAmbiente[iPosX+1][iPosY+1]<=iIdentificaPezMax)
  				vAlimentaTiburon(iPosX+1, iPosY+1);
  			else
  			{
		  			//Se mueve a una casilla al azar
		  			iAmbiente[iPosX][iPosY]--;
	  				if (iAmbiente[iPosX][iPosY]<iIdentificaTiburonMin)
	  				{
	  					iAmbiente[iPosX][iPosY]=0;
	  					//System.out.println("Muere un Tiburon");
	  				}
	  				else		  			
		  			{
		  				int iCeldaContiguaX=1, iCeldaContiguaY=1;
  						do
			 			{
							if (objAzar.nextInt()<0) iCeldaContiguaX = -1; else iCeldaContiguaX = 1;
							if (objAzar.nextInt()<0) iCeldaContiguaY = -1; else iCeldaContiguaY = 1;
	  					}while (iPosX+iCeldaContiguaX<=0 || iPosX+iCeldaContiguaX>=iMaximoTablero || iPosY+iCeldaContiguaY<=0 || iPosY+iCeldaContiguaY>=iMaximoTablero);

						if (iAmbiente[iPosX+iCeldaContiguaX][iPosY+iCeldaContiguaY]==0)
						{
							iAmbiente[iPosX+iCeldaContiguaX][iPosY+iCeldaContiguaY]=iAmbiente[iPosX][iPosY];
							iAmbiente[iPosX][iPosY]=0;
						}
	  				}
			}
 		}

  }
  
  void	vAlimentaPez(int iAlimentaX, int iAlimentaY)
  {
  	iAmbiente[iAlimentaX][iAlimentaY]=iAmbiente[iPosX][iPosY]+iAlimentaVegetal;
  	iAmbiente[iPosX][iPosY]=0;

	//Chequea si se multiplica
	if (iAmbiente[iAlimentaX][iAlimentaY]>=iIdentificaPezMax)
	{
		iAmbiente[iAlimentaX][iAlimentaY]=iIdentificaPezMax;
		int iCeldaMultiplica = Math.abs(objAzar.nextInt()%9);
		int iCeldaContiguaX = iRetornaPosX(iCeldaMultiplica);
		int iCeldaContiguaY = iRetornaPosY(iCeldaMultiplica);
		if (iAlimentaX+iCeldaContiguaX>=1 && iAlimentaX+iCeldaContiguaX<iMaximoTablero && iAlimentaY+iCeldaContiguaY>=1 && iAlimentaY+iCeldaContiguaY<iMaximoTablero)
			if (iAmbiente[iAlimentaX+iCeldaContiguaX][iAlimentaY+iCeldaContiguaY]==0)
			{
  				iAmbiente[iAlimentaX][iAlimentaY]=(iIdentificaPezMin+iIdentificaPezMax)/2;
  				iAmbiente[iAlimentaX+iCeldaContiguaX][iAlimentaY+iCeldaContiguaY]=(iIdentificaPezMin+iIdentificaPezMax)/2;
  				//System.out.println("Nace un Pez");
  			}
  	}
  }
  
  void	vAlimentaTiburon(int iAlimentaX, int iAlimentaY)
  {
  	iAmbiente[iAlimentaX][iAlimentaY]=iAmbiente[iPosX][iPosY]+iAlimentaPez;
  	iAmbiente[iPosX][iPosY]=0;

	//Chequea si se multiplica
	if (iAmbiente[iAlimentaX][iAlimentaY]>=iIdentificaTiburonMax)
	{
		iAmbiente[iAlimentaX][iAlimentaY]=iIdentificaTiburonMax;
		int iCeldaMultiplica = Math.abs(objAzar.nextInt()%9);
		int iCeldaContiguaX = iRetornaPosX(iCeldaMultiplica);
		int iCeldaContiguaY = iRetornaPosY(iCeldaMultiplica);
		if (iAlimentaX+iCeldaContiguaX>=1 && iAlimentaX+iCeldaContiguaX<iMaximoTablero && iAlimentaY+iCeldaContiguaY>=1 && iAlimentaY+iCeldaContiguaY<iMaximoTablero)
			if (iAmbiente[iAlimentaX+iCeldaContiguaX][iAlimentaY+iCeldaContiguaY]==0)
			{
  				iAmbiente[iAlimentaX][iAlimentaY]=(iIdentificaTiburonMin+iIdentificaTiburonMax)/2;
  				iAmbiente[iAlimentaX+iCeldaContiguaX][iAlimentaY+iCeldaContiguaY]=(iIdentificaTiburonMin+iIdentificaTiburonMax)/2;
  				//System.out.println("Nace un Tiburon");
  			}
  	}
  }
  
  int iRetornaPosX(int iCeldaMultiplica)
  {
  	if (iCeldaMultiplica==0) return -1;
  	if (iCeldaMultiplica==1) return 0;
  	if (iCeldaMultiplica==2) return 1;
  	if (iCeldaMultiplica==3) return -1;
  	if (iCeldaMultiplica==4) return 1;
  	if (iCeldaMultiplica==5) return -1;
  	if (iCeldaMultiplica==6) return 0;
   	if (iCeldaMultiplica==7) return 1;
   	return 0;
  }
  
  int iRetornaPosY(int iCeldaMultiplica)
  {
  	if (iCeldaMultiplica==0) return -1;
  	if (iCeldaMultiplica==1) return -1;
  	if (iCeldaMultiplica==2) return -1;
  	if (iCeldaMultiplica==3) return 0;
  	if (iCeldaMultiplica==4) return 0;
  	if (iCeldaMultiplica==5) return 1;
  	if (iCeldaMultiplica==6) return 1;
   	if (iCeldaMultiplica==7) return 1;
   	return 0;
  }  

  
  // Ejecucin del hilo
  public void run()
  {
	while(true)
    {
	  	//Voy de celda en celda		
	  	iPosX = (int) (objAzar.nextFloat()*(iMaximoTablero-iMinimoTablero))+iMinimoTablero;
	  	iPosY = (int) (objAzar.nextFloat()*(iMaximoTablero-iMinimoTablero))+iMinimoTablero; 

		if (iAmbiente[iPosX][iPosY]!=0)
		{
    		   	vVivir();
    		   	repaint();
			    try
        		{
        			Thread.sleep(1);
        		}
        		catch (InterruptedException E)
        		{}
		}
    }
  }
 
  // Mtodos que siempre van a estar
  public void start()
  {
        if (objHilo == null)
        {
            objHilo = new Thread(this);
            objHilo.start();
        }
  }   
  
  public void stop()
  {
        if (objHilo != null)
        {
            objHilo.stop();
            objHilo = null;
        }
  }
  
  //Para activar el double buffer
  public void update(Graphics objGrafico)
  {
      paint(objGrafico);
  }

}

//==============================================================================================================
//La ventana en donde se coloca la matriz de simulacin
//==============================================================================================================
class Ventana extends Frame
{
	Matriz objMatriz = new Matriz();
	
    static Button btnIniciar = new Button();
    static Button btnDetener = new Button();
    static Button btnContinuar = new Button();
    static Button btnSalir = new Button();

	static TextField txtLimiteVegetales = new TextField();
	static TextField txtLimitePeces = new TextField();
	static TextField txtLimiteTiburones = new TextField();
	static TextField txtIdentificaVegetalMin = new TextField();
	static TextField txtIdentificaVegetalMax = new TextField();
	static TextField txtIdentificaPezMin = new TextField();
	static TextField txtIdentificaPezMax = new TextField();
	static TextField txtIdentificaTiburonMin = new TextField();
	static TextField txtIdentificaTiburonMax = new TextField();
	static TextField txtAlimentaVegetal = new TextField();
	static TextField txtAlimentaPez = new TextField();

	static Label lblLimiteVegetales = new Label();
	static Label lblLimitePeces = new Label();
	static Label lblLimiteTiburones = new Label();
	static Label lblIdentificaVegetalMin = new Label();
	static Label lblIdentificaVegetalMax = new Label();
	static Label lblIdentificaPezMin = new Label();
	static Label lblIdentificaPezMax = new Label();
	static Label lblIdentificaTiburonMin = new Label();
	static Label lblIdentificaTiburonMax = new Label();
	static Label lblAlimentaVegetal = new Label();
	static Label lblAlimentaPez = new Label();
		
    //Constructor
    public Ventana(String sbTitulo)
    {
    	super(sbTitulo);
    	
		//Se adiciona controles grficos de control de poblacin
		setLayout(null);
		
		lblLimiteVegetales.setText("Vegetales:");
		lblLimiteVegetales.setBounds(582, 28, 70, 25);
		add(lblLimiteVegetales);
		
		lblLimitePeces.setText("Peces:");
		lblLimitePeces.setBounds(582, 54, 70, 25);
		add(lblLimitePeces);

		lblLimiteTiburones.setText("Tiburones:");
		lblLimiteTiburones.setBounds(582, 80, 70, 25);
		add(lblLimiteTiburones);

		txtLimiteVegetales.setBounds(671, 28, 40, 25);
		txtLimiteVegetales.setText("300");
		add(txtLimiteVegetales);

		txtLimitePeces.setBounds(671, 54, 40, 25);
		txtLimitePeces.setText("50");
		add(txtLimitePeces);
		
		txtLimiteTiburones.setBounds(671, 80, 40, 25);
		txtLimiteTiburones.setText("10");
		add(txtLimiteTiburones);
    	
    	//Se adiciona controles grficos de control de vida
    	lblIdentificaVegetalMin.setText("Energa Mnima del Vegetal:");
		lblIdentificaVegetalMin.setBounds(582, 106, 160, 25);
		add(lblIdentificaVegetalMin);
		
    	lblIdentificaVegetalMax.setText("Energa Mxima del Vegetal:");
		lblIdentificaVegetalMax.setBounds(582, 132, 160, 25);
		add(lblIdentificaVegetalMax);
				
    	lblIdentificaPezMin.setText("Energa Mnima del Pez:");
		lblIdentificaPezMin.setBounds(582, 158, 160, 25);
		add(lblIdentificaPezMin);
		
    	lblIdentificaPezMax.setText("Energa Mxima del Pez:");
		lblIdentificaPezMax.setBounds(582, 184, 160, 25);
		add(lblIdentificaPezMax);
		
    	lblIdentificaTiburonMin.setText("Energa Mnima del Tiburn:");
		lblIdentificaTiburonMin.setBounds(582, 210, 160, 25);
		add(lblIdentificaTiburonMin);
		
    	lblIdentificaTiburonMax.setText("Energa Mxima del Tiburn:");
		lblIdentificaTiburonMax.setBounds(582, 236, 160, 25);
		add(lblIdentificaTiburonMax);
		
		txtIdentificaVegetalMin.setBounds(745, 106, 50, 25);
		txtIdentificaVegetalMin.setText("1000");
		add(txtIdentificaVegetalMin);

		txtIdentificaVegetalMax.setBounds(745, 132, 50, 25);
		txtIdentificaVegetalMax.setText("1020");
		add(txtIdentificaVegetalMax);
		
		txtIdentificaPezMin.setBounds(745, 158, 50, 25);
		txtIdentificaPezMin.setText("10000");
		add(txtIdentificaPezMin);

		txtIdentificaPezMax.setBounds(745, 184, 50, 25);
		txtIdentificaPezMax.setText("11000");
		add(txtIdentificaPezMax);

		txtIdentificaTiburonMin.setBounds(745, 210, 50, 25);
		txtIdentificaTiburonMin.setText("30000");
		add(txtIdentificaTiburonMin);

		txtIdentificaTiburonMax.setBounds(745, 236, 50, 25);
		txtIdentificaTiburonMax.setText("31000");
		add(txtIdentificaTiburonMax);
		
		//Se adiciona controles grficos de control de alimentacin
		lblAlimentaVegetal.setText("Alimenta Vegetal:");
		lblAlimentaVegetal.setBounds(582, 276, 120, 25);
		add(lblAlimentaVegetal);
		
    	lblAlimentaPez.setText("Alimenta Pez:");
		lblAlimentaPez.setBounds(582, 302, 120, 25);
		add(lblAlimentaPez);
		
		txtAlimentaVegetal.setBounds(730, 276, 40, 25);
		txtAlimentaVegetal.setText("80");
		add(txtAlimentaVegetal);

		txtAlimentaPez.setBounds(730, 302, 40, 25);
		txtAlimentaPez.setText("80");
		add(txtAlimentaPez);
		
		//Para iniciar la simulacin del autmata
		btnIniciar.setBounds(582, 342, 90, 30);
		btnIniciar.setLabel("Iniciar");
		add(btnIniciar);
		
		//Para detener la simulacin del autmata
		btnDetener.setBounds(682, 342, 90, 30);
		btnDetener.setLabel("Detener");
		add(btnDetener);		
		
		//Para continuar la simulacin del autmata
		btnContinuar.setBounds(582, 382, 90, 30);
		btnContinuar.setLabel("Continuar");
		add(btnContinuar);		

		//Para salir
		btnSalir.setBounds(682, 382, 90, 30);
		btnSalir.setLabel("Salir");
		add(btnSalir);
		
		//Adiciona el evento del botn Iniciar
        btnIniciar.addActionListener
		(
	    	new java.awt.event.ActionListener()
	    	{
	        	public void actionPerformed(java.awt.event.ActionEvent e)
				{
					objMatriz.stop();	
					vInicializa();
					objMatriz.start();
				}
	    	}
		);
		
		//Adiciona el evento del botn Detener
        btnDetener.addActionListener
		(
	    	new java.awt.event.ActionListener()
	    	{
	        	public void actionPerformed(java.awt.event.ActionEvent e)
				{
					objMatriz.stop();
				}
	    	}
		);
		
		//Adiciona el evento del botn Continuar
        btnContinuar.addActionListener
		(
	    	new java.awt.event.ActionListener()
	    	{
	        	public void actionPerformed(java.awt.event.ActionEvent e)
				{
					objMatriz.start();
				}
	    	}
		);
		
		//Adiciona el evento del botn Salir
        btnSalir.addActionListener
		(
	    	new java.awt.event.ActionListener()
	    	{
	        	public void actionPerformed(java.awt.event.ActionEvent e)
				{
					objMatriz.stop();
					hide();
    				dispose();
				}
	    	}
		);		
		

    	
		//Adiciona el tablero
		add(objMatriz);
		objMatriz.setBounds(0, 0, 580, 550);
		
		vInicializa();
		objMatriz.start();
	}
	
	void vInicializa()
	{
		int iLimiteVegetales=0, iLimitePeces=0, iLimiteTiburones=0;
		int iIdentificaVegetalMin=0, iIdentificaVegetalMax=0;
		int iIdentificaPezMin=0, iIdentificaPezMax=0;
		int iIdentificaTiburonMin=0, iIdentificaTiburonMax=0;
		int iAlimentaVegetal=0, iAlimentaPez=0;
		
		String sbLimiteVegetales = txtLimiteVegetales.getText();
		if (sbLimiteVegetales.length()!=0) iLimiteVegetales = Integer.parseInt(sbLimiteVegetales);
  	
		String sbLimitePeces = txtLimitePeces.getText();
		if (sbLimitePeces.length()!=0) iLimitePeces = Integer.parseInt(sbLimitePeces);
		
		String sbLimiteTiburones = txtLimiteTiburones.getText();
		if (sbLimiteTiburones.length()!=0) iLimiteTiburones = Integer.parseInt(sbLimiteTiburones);
		
		String sbIdentificaVegetalMin = txtIdentificaVegetalMin.getText();
		if (sbIdentificaVegetalMin.length()!=0) iIdentificaVegetalMin = Integer.parseInt(sbIdentificaVegetalMin);

		String sbIdentificaVegetalMax = txtIdentificaVegetalMax.getText();
		if (sbIdentificaVegetalMax.length()!=0) iIdentificaVegetalMax = Integer.parseInt(sbIdentificaVegetalMax);

		String sbIdentificaPezMin = txtIdentificaPezMin.getText();
		if (sbIdentificaPezMin.length()!=0) iIdentificaPezMin = Integer.parseInt(sbIdentificaPezMin);

		String sbIdentificaPezMax = txtIdentificaPezMax.getText();
		if (sbIdentificaPezMax.length()!=0) iIdentificaPezMax = Integer.parseInt(sbIdentificaPezMax);
		
		String sbIdentificaTiburonMin = txtIdentificaTiburonMin.getText();
		if (sbIdentificaTiburonMin.length()!=0) iIdentificaTiburonMin = Integer.parseInt(sbIdentificaTiburonMin);
		
		String sbIdentificaTiburonMax = txtIdentificaTiburonMax.getText();
		if (sbIdentificaTiburonMax.length()!=0) iIdentificaTiburonMax = Integer.parseInt(sbIdentificaTiburonMax);

		String sbAlimentaVegetal = txtAlimentaVegetal.getText();
		if (sbAlimentaVegetal.length()!=0) iAlimentaVegetal = Integer.parseInt(sbAlimentaVegetal);

		String sbAlimentaPez = txtAlimentaPez.getText();
		if (sbAlimentaPez.length()!=0) iAlimentaPez = Integer.parseInt(sbAlimentaPez);

   		objMatriz.vParametros(iLimiteVegetales, iLimitePeces, iLimiteTiburones,
   							 iIdentificaVegetalMin, iIdentificaVegetalMax,
   							 iIdentificaPezMin, iIdentificaPezMax, 
   							 iIdentificaTiburonMin, iIdentificaTiburonMax,
   							 iAlimentaVegetal, iAlimentaPez);
   										
	}
}

//==============================================================================================================
//Inicializa el automata
//==============================================================================================================
public class Automata extends Applet
{
    static Ventana fraContenedor;
	Button btnBoton;

    public static void main(String sbParametros[])
    {
    	Automata objAutomata = new Automata();
    	objAutomata.vInicia();    	
		
		fraContenedor.addWindowListener
		(
			new java.awt.event.WindowAdapter()
			{
				public void windowClosing(java.awt.event.WindowEvent e)
				{
					System.exit(0);
				}
			}
		);		
    }
    
    //Se inicia antes de dar vida a la ventana
	public void init()
    {
	    btnBoton = new Button("Oprima aqu para activar el Autmata");
	    add(btnBoton);
    }
    
    public boolean action (Event objEvento, Object objObjeto)
    {
    	if (objEvento.target == btnBoton)
    		vInicia();

    	return true;
    }
    
    public void vInicia()
    {
		if (fraContenedor != null)
		{
			fraContenedor.hide();
			fraContenedor.dispose();
		}
		
		fraContenedor = new Ventana("Autmata celular. Versin 1.00");
        fraContenedor.setSize(800, 570);
        fraContenedor.show(); //Mostramos la ventana
    }
  
}